"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _constants_1 = require("../constants");
var directives_1 = require("./directives");
exports.walkContainer = function (container, filter, directiveCallback, nodeCallback) {
    container.each(function (node) {
        if (node.type !== _constants_1.COMMENT_TYPE && !filter.includes(node.type))
            return;
        if (node.type === _constants_1.COMMENT_TYPE) {
            var comment = node;
            var controlDirective = directives_1.getControlDirective(comment);
            if (controlDirective) {
                directiveCallback(comment, controlDirective);
            }
        }
        else {
            nodeCallback(node);
        }
    });
};
