"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _constants_1 = require("../constants");
var CONTROL_DIRECTIVE_VALUES = Object.values(_constants_1.CONTROL_DIRECTIVE);
var CONTROL_DIRECTIVE_BLOCK_VALUES = Object.values(_constants_1.CONTROL_DIRECTIVE_BLOCK);
exports.isValidMatchDirective = function (match) {
    return CONTROL_DIRECTIVE_VALUES.includes("" + match[2]) &&
        (match[1] === undefined ||
            CONTROL_DIRECTIVE_BLOCK_VALUES.includes("" + match[1]));
};
exports.getControlDirective = function (comment) {
    var commentStr = comment.toString();
    var match = commentStr.match(_constants_1.RTL_CONTROL_DIRECTIVE_REG_EXP);
    if (match && exports.isValidMatchDirective(match)) {
        var controlDirective = {
            directive: match[2]
        };
        if (match[1]) {
            controlDirective.block = match[1];
        }
        if (match[3]) {
            controlDirective.raw = match[3];
        }
        return controlDirective;
    }
    return null;
};
exports.isIgnoreDirectiveInsideAnIgnoreBlock = function (controlDirective, controlDirectives) { return (controlDirective.directive === _constants_1.CONTROL_DIRECTIVE.IGNORE &&
    !controlDirective.block &&
    controlDirectives[_constants_1.CONTROL_DIRECTIVE.IGNORE] &&
    controlDirectives[_constants_1.CONTROL_DIRECTIVE.IGNORE].block === _constants_1.CONTROL_DIRECTIVE_BLOCK.BEGIN); };
exports.checkDirective = function (controlDirectives, directiveType) {
    var directive = controlDirectives[directiveType];
    if (directive) {
        var block = directive.block;
        if (block !== _constants_1.CONTROL_DIRECTIVE_BLOCK.BEGIN) {
            delete controlDirectives[directiveType];
        }
        if (block !== _constants_1.CONTROL_DIRECTIVE_BLOCK.END) {
            return true;
        }
    }
    return false;
};
